Bug 1662170 - Review Request: ssh-tools - collection of various tools using ssh
Summary: Review Request: ssh-tools - collection of various tools using ssh
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2018-12-26 17:04 UTC by sven.wick
Modified: 2019-06-20 23:42 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
zebob.m: fedora-review?


Attachments (Terms of Use)

Description sven.wick 2018-12-26 17:04:03 UTC
Spec URL: https://raw.githubusercontent.com/vaporup/pkg/master/ssh-tools/fedora/ssh-tools.spec
SRPM URL: https://github.com/vaporup/pkg/raw/master/ssh-tools/fedora/ssh-tools-1.5-1.fc29.src.rpm

Description:

Hi,

I try to package ssh-tools but have never created a package for Fedora before.

Would be nice if someone could give me some hints
to my first spec file.

Thanks...

Comment 1 Markku Korkeala 2019-01-08 20:19:55 UTC
This is not official review as I'm not sponsored as a packager. See the Issues list for things that need correction.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== Issues =====

Man pages must not have 0755-permission, 0644 is enough.
There is no changelog entries, you should include one for initial package.
The shell-scripts have /usr/bin/env in shebangs, see https://fedoraproject.org/wiki/Packaging:Guidelines#Shebang_lines
Summary in spec-file should be capitalized.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 6 files have unknown license. Detailed
     output of licensecheck in /home/pake/Src/fedora-rpm/reviews/ssh-tools
     /review-ssh-tools/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[!]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[!]: Package must not have env, /bin/env and /usr/bin/env in shebang lines.

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ssh-tools-1.5-1.fc29.noarch.rpm
          ssh-tools-1.5-1.fc29.src.rpm
ssh-tools.noarch: W: summary-not-capitalized C collection of various tools using ssh
ssh-tools.noarch: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.noarch: E: no-changelogname-tag
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-diff.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-facts.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-hostkeys.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-ping.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-version.1.gz
ssh-tools.src: W: summary-not-capitalized C collection of various tools using ssh
ssh-tools.src: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.src: E: no-changelogname-tag
ssh-tools.src:28: W: mixed-use-of-spaces-and-tabs (spaces: line 28, tab: line 1)
2 packages and 0 specfiles checked; 2 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
ssh-tools.noarch: W: summary-not-capitalized C collection of various tools using ssh
ssh-tools.noarch: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.noarch: E: no-changelogname-tag
ssh-tools.noarch: W: invalid-url URL: https://github.com/vaporup/ssh-tools/ <urlopen error [Errno -2] Name or service not known>
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-diff.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-facts.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-hostkeys.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-ping.1.gz
ssh-tools.noarch: W: spurious-executable-perm /usr/share/man/man1/ssh-version.1.gz
1 packages and 0 specfiles checked; 1 errors, 8 warnings.



Requires
--------
ssh-tools (rpmlib, GLIBC filtered):
    /usr/bin/bash
    bash
    openssh-clients



Provides
--------
ssh-tools:
    ssh-tools



Source checksums
----------------
https://github.com/vaporup/ssh-tools/archive/v1.5.tar.gz :
  CHECKSUM(SHA256) this package     : 001e2c796c00236a7f4c5dd29b64eb5cdcf550f71f7017d34756ad41c02204bc
  CHECKSUM(SHA256) upstream package : 001e2c796c00236a7f4c5dd29b64eb5cdcf550f71f7017d34756ad41c02204bc


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -n ssh-tools
Buildroot used: fedora-29-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 sven.wick 2019-01-09 00:32:41 UTC
OK, updated the spec file which fixes all issues except the shebang one
because the shebang gets replaced automatically which the Wiki URL also mentions

Comment 3 Markku Korkeala 2019-01-16 19:26:01 UTC
The new version fixed rpmlint errors , now there is few warning left (see below). Otherwise the package looks good to be approved from my part.


Rpmlint
-------
Checking: ssh-tools-1.5-1.fc29.noarch.rpm
          ssh-tools-1.5-1.fc29.src.rpm
ssh-tools.noarch: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.src: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.src:28: W: mixed-use-of-spaces-and-tabs (spaces: line 28, tab: line 1)
2 packages and 0 specfiles checked; 0 errors, 3 warnings.

Comment 4 Robert-André Mauchin 2019-02-15 23:05:19 UTC
 - Use "install -p" to keep file timestamps

 - Use a better name for your archive:

Source0:	https://github.com/vaporup/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

 - Don't use the .gz extension but a glob for man pages, because compression might change in the future:

%{_mandir}/man1/ssh-*.1.*



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated". 6 files have unknown license. Detailed
     output of licensecheck in /home/bob/packaging/review/ssh-tools/review-
     ssh-tools/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[!]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ssh-tools-1.5-1.fc30.noarch.rpm
          ssh-tools-1.5-1.fc30.src.rpm
ssh-tools.noarch: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.src: W: spelling-error %description -l en_US hostkeys -> hotkeys, host keys, host-keys
ssh-tools.src:28: W: mixed-use-of-spaces-and-tabs (spaces: line 28, tab: line 1)
2 packages and 0 specfiles checked; 0 errors, 3 warnings.



Don't forget you'll need to find a sponsor too when your package is approved.

Comment 5 sven.wick 2019-06-20 23:42:55 UTC
1) Fixed mixed-use-of-spaces-and-tabs of rpmlint
2) Use "install -p" to keep file timestamps
3) Use a glob for man pages

Not sure about the archive name.
I packaged ssh-tools already for other distros which use this URL scheme from Github

Also not sure about the other rpmlint warning.
Maybe I should rename the binary in a future release,
so it won't be recognized as spelling error.


Note You need to log in before you can comment on or make changes to this bug.